Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MPF.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MPF.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/MPF.pm	(revision 34921)
@@ -6,5 +6,5 @@
 # Revisions:    06/12/2009 - P. Harvey Created
 #
-# References:   1) http://www.cipa.jp/english/hyoujunka/kikaku/pdf/DC-007_E.pdf
+# References:   1) http://www.cipa.jp/std/documents/e/DC-007_E.pdf
 #------------------------------------------------------------------------------
 
@@ -16,16 +16,19 @@
 use Image::ExifTool::Exif;
 
-$VERSION = '1.05';
+$VERSION = '1.14';
 
 sub ProcessMPImageList($$$);
 
-# Tags found in MPF APP2 segment in JPEG images
+# Tags found in APP2 MPF segment in JPEG images
 %Image::ExifTool::MPF::Main = (
     GROUPS => { 0 => 'MPF', 1 => 'MPF0', 2 => 'Image'},
     NOTES => q{
         These tags are part of the CIPA Multi-Picture Format specification, and are
-        found in the APP2 "MPF" segment of JPEG images.  See
-        L<http://www.cipa.jp/english/hyoujunka/kikaku/pdf/DC-007_E.pdf> for the
-        official specification.
+        found in the APP2 "MPF" segment of JPEG images.  MPImage data referenced
+        from this segment is stored as a JPEG trailer.  The MPF tags are not
+        writable, however the MPF segment may be deleted as a group (with "MPF:All")
+        but then the JPEG trailer should also be deleted (with "Trailer:All").  See
+        L<https://web.archive.org/web/20190713230858/http://www.cipa.jp/std/documents/e/DC-007_E.pdf>
+        for the official specification.
     },
     0xb000 => 'MPFVersion',
@@ -70,5 +73,5 @@
             },
         ],
-    },          
+    },
     0xb202 => 'PanOverlapH',
     0xb203 => 'PanOverlapV',
@@ -95,5 +98,5 @@
         The first MPF "Large Thumbnail" image is extracted as PreviewImage, and the
         rest of the embedded MPF images are extracted as MPImage#.  The
-        ExtractEmbedded (-ee) option may be used to extract information from these
+        L<ExtractEmbedded|../ExifTool.html#ExtractEmbedded> (-ee) option may be used to extract information from these
         embedded images.
     },
@@ -103,7 +106,7 @@
         Mask => 0xf8000000,
         PrintConv => { BITMASK => {
-            29 => 'Representative image',
-            30 => 'Dependent child image',
-            31 => 'Dependent parent image',
+            2 => 'Representative image',
+            3 => 'Dependent child image',
+            4 => 'Dependent parent image',
         }},
     },
@@ -152,5 +155,5 @@
 # extract MP Images as composite tags
 %Image::ExifTool::MPF::Composite = (
-    GROUPS => { 2 => 'Image' },
+    GROUPS => { 2 => 'Preview' },
     MPImage => {
         Require => {
@@ -161,5 +164,5 @@
         Notes => q{
             the first MPF "Large Thumbnail" is extracted as PreviewImage, and the rest
-            of the embedded MPF images are extracted as MPImage#.  The ExtractEmbedded
+            of the embedded MPF images are extracted as MPImage#.  The L<ExtractEmbedded|../ExifTool.html#ExtractEmbedded>
             option may be used to extract information from these embedded images.
         },
@@ -167,4 +170,5 @@
         RawConv => q{
             require Image::ExifTool::MPF;
+            @grps = $self->GetGroup($$val{0});  # set groups from input tag
             Image::ExifTool::MPF::ExtractMPImages($self);
         },
@@ -181,16 +185,16 @@
 sub ExtractMPImages($)
 {
-    my $exifTool = shift;
-    my $ee = $exifTool->Options('ExtractEmbedded');
-    my $saveBinary = $exifTool->Options('Binary');
+    my $et = shift;
+    my $ee = $et->Options('ExtractEmbedded');
+    my $saveBinary = $et->Options('Binary');
     my ($i, $didPreview, $xtra);
 
     for ($i=1; $xtra or not defined $xtra; ++$i) {
         # run through MP images in the same order they were extracted
-        $xtra = defined $$exifTool{VALUE}{"MPImageStart ($i)"} ? " ($i)" : '';
-        my $off = $exifTool->GetValue("MPImageStart$xtra");
-        my $len = $exifTool->GetValue("MPImageLength$xtra");
+        $xtra = defined $$et{VALUE}{"MPImageStart ($i)"} ? " ($i)" : '';
+        my $off = $et->GetValue("MPImageStart$xtra", 'ValueConv');
+        my $len = $et->GetValue("MPImageLength$xtra", 'ValueConv');
         if ($off and $len) {
-            my $type = $exifTool->GetValue("MPImageType$xtra", 'ValueConv');
+            my $type = $et->GetValue("MPImageType$xtra", 'ValueConv');
             my $tag = "MPImage$i";
             # store first "Large Thumbnail" as a PreviewImage
@@ -199,25 +203,23 @@
                 $didPreview = 1;
             }
-            $exifTool->Options('Binary', 1) if $ee;
-            my $val = Image::ExifTool::Exif::ExtractImage($exifTool, $off, $len, $tag);
-            $exifTool->Options('Binary', $saveBinary) if $ee;
+            $et->Options('Binary', 1) if $ee;
+            my $val = Image::ExifTool::Exif::ExtractImage($et, $off, $len, $tag);
+            $et->Options('Binary', $saveBinary) if $ee;
             next unless defined $val;
             unless ($Image::ExifTool::Extra{$tag}) {
-                Image::ExifTool::AddTagToTable(\%Image::ExifTool::Extra, $tag, {
+                AddTagToTable(\%Image::ExifTool::Extra, $tag, {
                     Name => $tag,
-                    Groups => { 0 => 'Composite', 1 => 'Composite', 2 => 'Image'},
+                    Groups => { 0 => 'Composite', 1 => 'Composite', 2 => 'Preview'},
                 });
             }
-            my $key = $exifTool->FoundTag($tag, $val);
-            # set groups for PreviewImage
-            if ($tag eq 'PreviewImage') {
-                $exifTool->SetGroup($key, 'Composite', 0);
-                $exifTool->SetGroup($key, 'Composite');
-            }
+            my $key = $et->FoundTag($tag, $val, $et->GetGroup("MPImageStart$xtra"));
             # extract information from MP images if ExtractEmbedded option used
             if ($ee) {
-                $$exifTool{DOC_NUM} = $i;
-                $exifTool->ExtractInfo($val, { ReEntry => 1 });
-                delete $$exifTool{DOC_NUM};
+                my $oldBase = $$et{BASE};
+                $$et{BASE} = $off;
+                $$et{DOC_NUM} = $i;
+                $et->ExtractInfo($val, { ReEntry => 1 });
+                delete $$et{DOC_NUM};
+                $$et{BASE} = $oldBase;
             }
         }
@@ -232,15 +234,15 @@
 sub ProcessMPImageList($$$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $num = int($$dirInfo{DirLen} / 16); # (16 bytes per MP Entry)
     $$dirInfo{DirLen} = 16;
     my ($i, $success);
-    my $oldG1 = $$exifTool{SET_GROUP1};
+    my $oldG1 = $$et{SET_GROUP1};
     for ($i=0; $i<$num; ++$i) {
-        $$exifTool{SET_GROUP1} = '+' . ($i + 1);
-        $success = $exifTool->ProcessBinaryData($dirInfo, $tagTablePtr);
+        $$et{SET_GROUP1} = '+' . ($i + 1);
+        $success = $et->ProcessBinaryData($dirInfo, $tagTablePtr);
         $$dirInfo{DirStart} += 16;
     }
-    $$exifTool{SET_GROUP1} = $oldG1;
+    $$et{SET_GROUP1} = $oldG1;
     return $success;
 }
@@ -265,5 +267,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
@@ -274,5 +276,5 @@
 =over 4
 
-=item L<http://www.cipa.jp/english/hyoujunka/kikaku/pdf/DC-007_E.pdf>
+=item L<http://www.cipa.jp/std/documents/e/DC-007_E.pdf>
 
 =back
